unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,Unit3, Buttons, ExtCtrls, MMsystem, Grids,
  DBGrids, Spin, ComCtrls, Gauges, Mask, IBCtrls;

type
  TForm1 = class(TForm)
    Button7: TButton;
    Label80: TLabel;
    Label81: TLabel;
    voltage: TTrackBar;
    tok: TTrackBar;
    Edit6: TEdit;
    Timer1: TTimer;
    Edit9: TEdit;
    Label82: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Label83: TLabel;
    Edit12: TEdit;
    Edit13: TEdit;
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Bevel1: TBevel;
    Shape1: TShape;
    Bevel2: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure voltageChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure tokChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);

 //   procedure Button7Click(Sender: TObject);

private
    { Private declarations }
  public
    { Public declarations }
//    procedure NewThread.Execute;
    Procedure Purge;
    Procedure SetupDCB;
 //    var
 //     FComm,COMM:THandle;
  end;
/////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////
var

       Value,DiValue : Smallint;
    LedStatus, tempBit : Smallint;

       crc_arr:array[0..2] of integer;
        buff, buff1:aa;
        p:integer;
        total,errors:integer;          // -    
        activity:integer;             //0-   1- 
        volt,cur:integer;             //       

        OverWrite:TOverlapped;
        OverRead:TOverlapped;
        num_inf: integer;
        Form1: TForm1;
        NewThread:TCom1Thread;
        FComm,COMM:THandle;
implementation


{$R *.dfm}


procedure Write_Massiv(buffer:aa;lenth:integer);


 const
  POLY811 = $118;

 var
   crc:integer;//byte;
   i,j: integer;

   read:cardinal;

begin

         crc:=0;
   for j:=0 to lenth do
   begin
         crc:=crc XOR buffer[j];

         for i:=0 to 7 do
         begin
                if((crc AND $01)=1) then
                        crc:=crc XOR POLY811;
                crc:=crc SHR 1;
         end;
   end;


    buffer[lenth+1]:=crc;

//    if COMM=FComm then form1.Memo3.Lines.Add('crc8:'+ inttostr(buffer[lenth+1]));
     
     //    Rs232   Com1
    OverWrite.hEvent:=CreateEvent(nil,True,False,nil);
    if OverWrite.hEvent = Null then
      raise Exception.Create('Error creating write event');
    if (not WriteFile(FComm,buffer,lenth+2,read,@OverWrite))
        and (GetLastError <> ERROR_IO_PENDING) then begin
               Form1.Timer1.Enabled:=False;
                raise Exception.Create('Error writing port');

        end;

end;







procedure TForm1.FormCreate(Sender: TObject);
var

 CommPort:string;


begin
total:=0;
errors:=0;
activity:=0;

 NewThread:=TCom1Thread.Create(False);
     
     CommPort:= '\\.\com1';
     Fcomm:=CreateFile('com1',//PChar(CommPort),
                        Generic_Read or Generic_Write,
                        0,
                        nil,
                        OPEN_EXISTING,
                        FILE_FLAG_OVERLAPPED,
                        0
                        );

     if(FComm=Invalid_Handle_Value)
       then
        begin
     {    NewThread.Terminate;         }
         Form1.Close;
     {   raise Exception.Create('Error writing port');       }
         exit;
        end;

        SetupDcB;
        Purge;
        if not SetCommMask(Fcomm, EV_RXCHAR or EV_RXFLAG) then raise Exception.Create('Error setting port mask');

COMM:=FComm;
 buff[0]:=51;                   // 
 buff[1]:=3;//110; Form1.Edit2.text:=inttostr(buf[1]);  // 
 buff[2]:=1;//110; Form1.Edit3.text:=inttostr(buf[2]);   //   
 buff[3]:=Form1.voltage.Position;//110; Form1.Edit4.text:=inttostr(buf[3]);   //   
 Write_Massiv(buff,3);
   sleep(20);

 buff[0]:=51;                   // 
 buff[1]:=4;//110; Form1.Edit2.text:=inttostr(buf[1]);  // 
 buff[2]:=1;//110; Form1.Edit3.text:=inttostr(buf[2]);   //   
 buff[3]:=Form1.voltage.Position;//110; Form1.Edit4.text:=inttostr(buf[3]);   //   
 Write_Massiv(buff,3);
   sleep(20);

 end;





 Procedure TForm1.Purge;
begin
  if PurgeComm(FComm,Purge_RxClear or Purge_TxClear)=false
   then exit;

end;


Procedure TForm1.SetupDCB;
var
 SemDcb:TDCB;
 myCommTimeouts:TCommTimeouts;
begin
 IF GetCommState(FComm,SemDcb)=false
        then
        begin
          exit;
        end;
    SemDcb.BaudRate:=28800;//19200; // 57600;//9600;//28800;
    SemDcb.ByteSize:=8;
    SemDcb.Parity:=Noparity;
    SemDcb.StopBits:=ONESTOPBIT;
    SemDCB.Flags:=RTS_Control_Disable+DTR_Control_Disable+EV_RXCHAR;

 IF SetCommState(FComm,SemDcb)=false
     then
     begin
     exit;
     end;
 IF GetCommTimeouts(FComm,myCommTimeouts)=false
      then
      begin

      exit;
      end;
  myCommTimeouts.ReadIntervalTimeout:=50;
  myCommTimeouts.ReadTotalTimeoutMultiplier:=1;
  myCommTimeouts.ReadTotalTimeoutConstant:=50;


 IF SetCommTimeouts(FComm,myCommTimeouts)=False
      then
      begin

      exit;
      end;
 IF SetCommState(FComm,SemDcb)=false
      then
      begin
     
      exit;
      end;
end;



{
procedure Write_Massiv(buffer:aa;lenth:integer);


 const
  POLY811 = $118;

 var
   crc:integer;//byte;
   i,j: integer;

   read:cardinal;

begin

         crc:=0;
   for j:=0 to lenth do
   begin
         crc:=crc XOR buffer[j];

         for i:=0 to 7 do
         begin
                if((crc AND $01)=1) then
                        crc:=crc XOR POLY811;
                crc:=crc SHR 1;
         end;
   end;


    buffer[lenth+1]:=crc;

//    if COMM=FComm then form1.Memo3.Lines.Add('crc8:'+ inttostr(buffer[lenth+1]));
     
     //    Rs232   Com1
    OverWrite.hEvent:=CreateEvent(nil,True,False,nil);
    if OverWrite.hEvent = Null then
      raise Exception.Create('Error creating write event');
    if (not WriteFile(FComm,buffer,lenth+2,read,@OverWrite))
        and (GetLastError <> ERROR_IO_PENDING) then begin
               Form1.Timer1.Enabled:=False;
                raise Exception.Create('Error writing port');

        end;

end;         }


function Read_Massiv(buffer:aa):aa;


 const
  POLY811 = $118;

 var
   crc:integer;//byte;
   i,j: integer;

   read:cardinal;


begin
     //    Rs232   Com1

       ReadFile(COMM,buffer,9,read,@OverRead);

//     form1.Memo3.Lines.Add('buffer['+inttostr(j)+']: '+inttostr(buffer[j]));

    result:=buffer;
end;


procedure TForm1.Button16Click(Sender: TObject);
 var
   crc:integer;//byte;
   i,j: integer;

   buf, buf2: aa;
   read:cardinal;


begin
 COMM:=FComm;                    //  - 
 buf[0]:=51;
 buf[1]:=2;      // Form1.Edit2.text:=inttostr(buf[1]);
 buf[2]:=0;      // Form1.Edit3.text:=inttostr(buf[2]);
 //buf[3]:=240;  // Form1.Edit4.text:=inttostr(buf[3]);

 Write_Massiv(buf,2);
   sleep(50);

 buf2:=Read_Massiv(buf2);




 end;



  procedure TForm1.Button7Click(Sender: TObject);
begin
     NewThread.Terminate;
     Form1.Close;
end;



{procedure TForm1.SpinEdit1Change(Sender: TObject);
var
   crc:integer;//byte;
   i,j: integer;

   buf, buf2: aa;
   read:cardinal;


begin
 COMM:=FComm;
 buf[0]:=51;                   // 
 buf[1]:=3;//110; Form1.Edit2.text:=inttostr(buf[1]);  // 
 buf[2]:=1;//110; Form1.Edit3.text:=inttostr(buf[2]);   //   
 buf[3]:=Form1.SpinEdit1.Value;//110; Form1.Edit4.text:=inttostr(buf[3]);   //   
 Write_Massiv(buf,3);
   sleep(50);

 buf2:=Read_Massiv(buf2);
end;                                          }

{procedure TForm1.SpinEdit2Change(Sender: TObject);
var
   crc:integer;//byte;
   i,j: integer;

   buf, buf2: aa;
   read:cardinal;


begin
 COMM:=FComm;
 buf[0]:=51;                    // 
 buf[1]:=4;                     // Form1.Edit2.text:=inttostr(buf[1]);  // 
 buf[2]:=1;                     // Form1.Edit3.text:=inttostr(buf[2]);   //   
 buf[3]:=Form1.SpinEdit2.Value; // Form1.Edit4.text:=inttostr(buf[3]);   //   
 Write_Massiv(buf,3);
   sleep(50);

 buf2:=Read_Massiv(buf2);
end;    }


procedure TForm1.voltageChange(Sender: TObject);
var
   crc:integer;//byte;
   i,j: integer;

   buf, buf2: aa;
   read:cardinal;


begin
if(activity=1) then begin
 COMM:=FComm;
 buf[0]:=51;                   // 
 buf[1]:=3;//110; Form1.Edit2.text:=inttostr(buf[1]);  // 
 buf[2]:=1;//110; Form1.Edit3.text:=inttostr(buf[2]);   //   
 buf[3]:=Form1.voltage.Position;//110; Form1.Edit4.text:=inttostr(buf[3]);   //   
 Write_Massiv(buf,3);
   sleep(20);
   end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const
  POLY811 = $118;
var
   crc:integer;//byte;
   i,j: integer;

   buf, buf2: aa;
   read:cardinal;


begin
  buf2:=buff1;
 COMM:=FComm;                    //  - 
 buf[0]:=51;
 buf[1]:=2;      // Form1.Edit2.text:=inttostr(buf[1]);
 buf[2]:=0;      // Form1.Edit3.text:=inttostr(buf[2]);

 Write_Massiv(buf,2);
   //sleep(50);
   //sleep(30);
   //sleep(100);


   COMM:=FComm;
   buf[0]:=51;                   // 
   buf[1]:=4;//110; Form1.Edit2.text:=inttostr(buf[1]);  // 
   buf[2]:=1;//110; Form1.Edit3.text:=inttostr(buf[2]);   //   
   buf[3]:=Form1.tok.Position;//110; Form1.Edit4.text:=inttostr(buf[3]);   //   
   Write_Massiv(buf,3);
   //  sleep(20);

     COMM:=FComm;
   buf[0]:=51;                   // 
   buf[1]:=3;//110; Form1.Edit2.text:=inttostr(buf[1]);  // 
   buf[2]:=1;//110; Form1.Edit3.text:=inttostr(buf[2]);   //   
   buf[3]:=Form1.voltage.Position;//110; Form1.Edit4.text:=inttostr(buf[3]);   //   
   Write_Massiv(buf,3);
   //  sleep(20);

 end;


 procedure TForm1.tokChange(Sender: TObject);
var
   crc:integer;//byte;
   i,j: integer;

   buf, buf2: aa;
   read:cardinal;


begin
if(activity=1) then begin
 COMM:=FComm;
 buf[0]:=51;                   // 
 buf[1]:=4;//110; Form1.Edit2.text:=inttostr(buf[1]);  // 
 buf[2]:=1;//110; Form1.Edit3.text:=inttostr(buf[2]);   //   
 buf[3]:=Form1.tok.Position;//110; Form1.Edit4.text:=inttostr(buf[3]);   //   
 Write_Massiv(buf,3);
   sleep(20);
   end;
// buf2:=Read_Massiv(buf2);
//Form1.Edit6.text:=inttostr(buf2[3]);

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
Form1.voltage.Position:=Form1.voltage.Position+1;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Form1.voltage.Position:=Form1.voltage.Position-1;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
Form1.tok.Position:=Form1.tok.Position+1;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
Form1.tok.Position:=Form1.tok.Position-1;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
if activity=0 then begin
activity:=1;
Form1.voltage.Position:=volt;
Form1.tok.Position:=cur;

Form1.voltage.Position:=volt;
Form1.tok.Position:=cur;

Form1.Shape1.Brush.Color:=clLime;

 end
 else begin

volt:=Form1.voltage.Position;
cur:=Form1.tok.Position;

Form1.voltage.Position:=0;
Form1.tok.Position:=0;

Form1.voltage.Position:=0;
Form1.tok.Position:=0;

Form1.Shape1.Brush.Color:=clRed;
activity:=0;
 end
end;

end.
